#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct NumericHistogramNode {
    #[builder(
        default,
        map(
            key(type = super::super::super::api::VariableName),
            value(type = super::NumericSeriesNode)
        )
    )]
    #[serde(
        rename = "inputs",
        skip_serializing_if = "std::collections::BTreeMap::is_empty",
        default
    )]
    inputs: std::collections::BTreeMap<
        super::super::super::api::VariableName,
        super::NumericSeriesNode,
    >,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::NumericHistogramBucketStrategy>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "bucketStrategy", skip_serializing_if = "Option::is_none", default)]
    bucket_strategy: Option<Box<super::NumericHistogramBucketStrategy>>,
}
impl NumericHistogramNode {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn inputs(
        &self,
    ) -> &std::collections::BTreeMap<
        super::super::super::api::VariableName,
        super::NumericSeriesNode,
    > {
        &self.inputs
    }
    #[inline]
    pub fn bucket_strategy(&self) -> Option<&super::NumericHistogramBucketStrategy> {
        self.bucket_strategy.as_ref().map(|o| &**o)
    }
}
